## ros-melodic-towr-ros 1.4.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(towr_ros)

add_compile_options(-std=c++11)

find_package(catkin REQUIRED COMPONENTS
  roscpp
  rosbag
  std_msgs
  visualization_msgs
  message_generation
  xpp_msgs
  xpp_states
  towr
)


## Generate messages in the 'msg' folder
add_message_files( FILES TowrCommand.msg )
generate_messages( DEPENDENCIES std_msgs xpp_msgs )


###################################
## catkin specific configuration ##
###################################
## The catkin_package macro generates cmake config files for your package
catkin_package(
   INCLUDE_DIRS include
   LIBRARIES ${PROJECT_NAME}
   CATKIN_DEPENDS xpp_states roscpp
   DEPENDS towr
)

###########
## Build ##
###########
include_directories(
  include
  ${catkin_INCLUDE_DIRS}
)

# The interface to derive from for ros integration
add_library(${PROJECT_NAME} SHARED
  src/towr_ros_interface.cc
)
add_dependencies(${PROJECT_NAME} 
  ${PROJECT_NAME}_gencpp
)
target_link_libraries(${PROJECT_NAME}
  ${catkin_LIBRARIES}
)


## An example executable that runs TOWR
add_executable(towr_ros_app 
  src/towr_ros_app.cc
)
add_dependencies(towr_ros_app 
  ${PROJECT_NAME}_gencpp
)
target_link_libraries(towr_ros_app
  ${catkin_LIBRARIES}
  ${PROJECT_NAME}
)


## Keyboard interfaces (ncurses)
find_package(Curses REQUIRED)
add_executable(towr_user_interface 
  src/towr_user_interface.cc
)
add_dependencies(towr_user_interface 
  ${PROJECT_NAME}_gencpp
)
target_link_libraries(towr_user_interface 
  ${catkin_LIBRARIES}
  ${CURSES_LIBRARIES}
)


# Display different terrains in rviz
add_executable(rviz_terrain_publisher 
  src/rviz_terrain_publisher.cc
)
add_dependencies(rviz_terrain_publisher 
  ${PROJECT_NAME}_gencpp
)
target_link_libraries(rviz_terrain_publisher
  ${catkin_LIBRARIES}
)


# Display goal pose in rviz
add_executable(goal_pose_publisher 
  src/goal_pose_publisher.cc
)
add_dependencies(goal_pose_publisher 
  ${PROJECT_NAME}_gencpp
) 
target_link_libraries(goal_pose_publisher
  ${catkin_LIBRARIES}
)


# (Optional) to manipulate ROS bags
add_executable(rosbag_traj_combiner 
  src/rosbag_traj_combiner.cc
)
target_link_libraries(rosbag_traj_combiner
  ${catkin_LIBRARIES}
)


add_executable(rosbag_geom_msg_extractor 
  src/rosbag_geom_msg_extractor.cc
)
target_link_libraries(rosbag_geom_msg_extractor
  ${catkin_LIBRARIES}
)


#############
## Install ##
#############
# Mark library for installation
install(
  TARGETS towr_ros_app
          towr_user_interface
          rviz_terrain_publisher
          goal_pose_publisher
          rosbag_traj_combiner
          rosbag_geom_msg_extractor
          ${PROJECT_NAME}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

# Mark header files for installation
install(
  DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
)

# Mark other files for installation
install(
  DIRECTORY launch rviz bash
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

=== debian/changelog ===
ros-melodic-towr-ros (1.4.1-0stretch) stretch; urgency=high

  * Merge pull request (#56 <https://github.com/ethz-adrl/towr/issues/56>) from ethz-adrl/expose-params
  * Contributors: Alexander Winkler, awinkler

 -- Alexander W. Winkler <alexander.w.winkler@gmail.com>  Thu, 04 Apr 2019 22:00:00 -0000

ros-melodic-towr-ros (1.4.0-0stretch) stretch; urgency=high

  * Facilitate towr_ros user extension (#34 <https://github.com/ethz-adrl/towr/issues/34>)
  * Add easy plotting of trajectories with rqt_bag
  * add option to visualize variable initialization
  * Allow shorthand to launch with gdb
  * Contributors: Alexander Winkler

 -- Alexander W. Winkler <alexander.w.winkler@gmail.com>  Sun, 29 Jul 2018 22:00:00 -0000

ros-melodic-towr-ros (1.3.2-0stretch) stretch; urgency=high

  * adapt to more generic ifopt solver interface.
  * Contributors: Alexander Winkler

 -- Alexander W. Winkler <alexander.w.winkler@gmail.com>  Mon, 16 Jul 2018 22:00:00 -0000

ros-melodic-towr-ros (1.3.1-0stretch) stretch; urgency=high

  * Improve API (#23 <https://github.com/ethz-adrl/towr/issues/23>)
  * add gait optimization and replay speed to UI
  * Add ROS and codefactor badges to readme (#22 <https://github.com/ethz-adrl/towr/issues/22>)
  * Contributors: Alexander Winkler

 -- Alexander W. Winkler <winklera@ethz.ch>  Mon, 09 Jul 2018 22:00:00 -0000

ros-melodic-towr-ros (1.3.0-0stretch) stretch; urgency=high

  * visualize goal state on terrain
  * Remove redundant rviz terrain visualizer and instead generate
    surface patches directly from height map information
  * correctly visualize rviz range-of-motion boxes
  * visualize first state
  * make GUI static
  * Contributors: Alexander Winkler

 -- Alexander W. Winkler <winklera@ethz.ch>  Fri, 06 Jul 2018 22:00:00 -0000

ros-melodic-towr-ros (1.2.2-0stretch) stretch; urgency=high

  * remove controller specifc code from towr_ros
  * removed exe subfolder
  * moved height map from towr_ros to towr
  * moved robots models and gait generator from towr_ros to towr
  * move dynamic and kinematic models from towr_ros -> towr
  * add ncurses and xterm dependencies to package.xml
  * Contributors: Alexander Winkler

 -- Alexander W. Winkler <winklera@ethz.ch>  Mon, 02 Jul 2018 22:00:00 -0000

ros-melodic-towr-ros (1.2.1-0stretch) stretch; urgency=high

  * adapt to revised ifopt version and build structure
  * preparation for ANYmal experiments
  * Contributors: Alexander Winkler

 -- Alexander W. Winkler <winklera@ethz.ch>  Fri, 29 Jun 2018 22:00:00 -0000

ros-melodic-towr-ros (1.2.0-0stretch) stretch; urgency=high

  * adapt to version 2.0.0 of ifopt (#17 <https://github.com/ethz-adrl/ifopt/pull/17>)
  * fix discrepancy between gap height map and rviz visualization
  * Contributors: Alexander Winkler

 -- Alexander W. Winkler <winklera@ethz.ch>  Sun, 24 Jun 2018 22:00:00 -0000

ros-melodic-towr-ros (1.1.0-0stretch) stretch; urgency=high

  * improve launch files and class names
  * add metapackage towr and move algorithm to towr_core
  * create separate ros independent example package "towr_examples"
  * adapt to separated ifopt packages
  * replaced ros-keyboard dependency with ncurses
  * clean-up matlab scripts
  * clean and document towr_ros
  * add documentaton to angular_state_converter->euler_converter
  * moved all robot specific model/gait generators out of towr -> towr_ros
  * use only one unified represenatation for nodes and states
  * added spline_holder to not always have to reconstruct from variables
  * separated spline and node values
  * changed to different namespace towr
  * renamed pkg from xpp_opt to towr
  * Contributors: Alexander Winkler

 -- Alexander W. Winkler <winklera@ethz.ch>  Mon, 05 Feb 2018 23:00:00 -0000

ros-melodic-towr-ros (1.0.0-0stretch) stretch; urgency=high



 -- Alexander W. Winkler <winklera@ethz.ch>  Mon, 18 Sep 2017 22:00:00 -0000

=== debian/control ===
Source: ros-melodic-towr-ros
Section: misc
Priority: extra
Maintainer: Alexander W. Winkler <alexander.w.winkler@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libncurses5-dev, ros-melodic-catkin, ros-melodic-message-generation, ros-melodic-message-runtime, ros-melodic-rosbag, ros-melodic-roscpp, ros-melodic-std-msgs, ros-melodic-towr, ros-melodic-visualization-msgs, ros-melodic-xpp-msgs, ros-melodic-xpp-states
Homepage: http://github.com/ethz-adrl/towr
Standards-Version: 3.9.2

Package: ros-melodic-towr-ros
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libncurses5-dev, ros-melodic-message-generation, ros-melodic-message-runtime, ros-melodic-rosbag, ros-melodic-roscpp, ros-melodic-rqt-bag, ros-melodic-rviz, ros-melodic-std-msgs, ros-melodic-towr, ros-melodic-visualization-msgs, ros-melodic-xpp-hyq, ros-melodic-xpp-msgs, ros-melodic-xpp-states, xterm
Description: A ROS dependent wrapper for towr.
 Adds a keyboard user interface to set different goal states, motions and robots and visualizes the produced motions plan in rviz using xpp.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-towr-ros//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install
